Subject: Taxonomy (was Re: [p2p-sip] Protocol Choice)

From: RoyR at saic-abingdon.com (Roy, Radhika (AEAD))
Date: Fri Sep 16 16:12:50 2005

Hi, David:

Great! It is good start.

I wonder whether we add another dimension in this discussion as follows:

1. Do we address both real-time and near/non-real-time p2p
communication?

2. Do we address only near/non-real-time communications?

3. Do we address only non-real-time communications?

Best regards,
Radhika

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of
David A. Bryan
Sent: Friday, September 16, 2005 11:02 AM
To: [email-masked]
Cc: Roy, Radhika (AEAD); Brijesh Kumar; Dean Willis;
[email-masked]; Johnston, Alan; Stastny Richard; Tschofenig,
Hannes
Subject: Taxonomy (was Re: [p2p-sip] Protocol Choice)

On 9/15/05, Henry Sinnreich <[email-masked]> wrote:

> All I am saying, these are options that need to investigated and
discussed,
> beyond an e-mail exchange here, where not all the authors of this work
may
> have seen the e-mails. I would be interested to see first some
taxonomy and
> framework, instead of arguing on email.
> 
> My two cents,
> 
> Thanks, Henry

Hello all,

I agree with Henry that we should talk a bit about taxonomy here. We
have (I didn't even try to fill it all in, just wanted to list some of
the items, hopefully others on the list will fill in more details) :

0 Do we need P2P SIP?
    a yes
    b no, no need
    c no, use dynamic DNS for similar function
1 Applications of P2P in SIP 
    a using P2P for UAs
    b using P2P between a cluster of proxies (or mini proxy adaptors),
pure SIP to the UA
    c load balancing servers, otherwise conventional SIP
2 Mechanisms for conveying P2P information
    a SIP messages
    b Non-sip messages
3 Different approaches to hierarchy 
    a P2P mechanisms that do hierarchy explicitly
    b Using adaptors (gateways?) between different P2P realms
    c DNS between realms
4 P2P Protocol choice
    a DHT/CAN approaches
        i Chord or Chord-like
        ii Pastry
        iii Tapestry
        iv CAN
    b Broadcast/Flood based techniques
    c Social based
        i SPROUT

So for example the draft I submitted is a (1a, 2a, 3b (sort of, I only
mention it in passing), 4a(i) (only because I thought Chord is easiest
to understand, not necessarily the best solution)) approach (wow, that
sounds like a lawyer wrote it...and I hope all those parenthesis are
balanced ;) )

I think it might be a worthwhile exercise to flesh out the
option/taxonomy chart a bit (what other parameters (1/2/3) are on the
space? What other options are there within each parameter (a/b/c)? If
we get the options fleshed out a bit, we'll be in a better position to
discuss what is important and where we may want to take this work. Can
others expand on this, either with more parameters or other options
for each parameter?

As an aside, obviously we can also have sub-categories too -- under
2a, I have heard a lot of discussion about if REGISTER, PUBLISH, or
some new SIP message is the right mechanism, and once you choose the
message, you can debate how to represent information about new nodes
(what headers etc.)

David